function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

import React, { useEffect, useState, useMemo } from 'react';
import throttle from 'lodash/throttle';
var DELAY_TIME = 100;
var MARGIN = 10;
var MAIN_WIDTH_MIN = 200;
export var X_AXIS_WIDTH_MAX = 320;
export var X_AXIS_WIDTH = 220;
export var useResize = function useResize(rootRef, store) {
  var _useState = useState({}),
      _useState2 = _slicedToArray(_useState, 2),
      bounds = _useState2[0],
      setBounds = _useState2[1];

  var _useState3 = useState(true),
      _useState4 = _slicedToArray(_useState3, 2),
      draggable = _useState4[0],
      setDraggable = _useState4[1];

  var _useState5 = useState(false),
      _useState6 = _slicedToArray(_useState5, 2),
      isDragging = _useState6[0],
      setIsDragging = _useState6[1];

  var _useState7 = useState({
    x: X_AXIS_WIDTH,
    y: 0
  }),
      _useState8 = _slicedToArray(_useState7, 2),
      resizeNav = _useState8[0],
      setResizeNav = _useState8[1];

  function getBounds() {
    var current = rootRef.current;

    if (current) {
      var offsetWidth = current.offsetWidth;
      setBounds({
        width: offsetWidth
      });
    }
  }

  var limitGetBounds = useMemo(function () {
    return throttle(getBounds, DELAY_TIME);
  }, []);
  useEffect(function () {
    getBounds();
    window.addEventListener('resize', limitGetBounds, false);
    return function () {
      window.removeEventListener('resize', limitGetBounds);
    };
  }, []);

  function handleDrag(e, data) {
    if (data.deltaX) {
      setResizeNav({
        x: data.x,
        y: data.y
      });
    }
  }

  function handleStartDrag() {
    setIsDragging(true);
  }

  function handleUnsetDrag() {
    setIsDragging(false);
  }

  useEffect(function () {
    var navX = resizeNav.x;
    var computedLeft = bounds.width - MAIN_WIDTH_MIN;
    var nextResize = resizeNav;

    if (computedLeft < X_AXIS_WIDTH || navX < X_AXIS_WIDTH) {
      nextResize = _objectSpread(_objectSpread({}, resizeNav), {}, {
        x: X_AXIS_WIDTH
      });
    } else if (navX > X_AXIS_WIDTH_MAX) {
      nextResize = _objectSpread(_objectSpread({}, resizeNav), {}, {
        x: X_AXIS_WIDTH_MAX
      });
    } else if (computedLeft < navX) {
      nextResize = _objectSpread(_objectSpread({}, resizeNav), {}, {
        x: computedLeft
      });
    }

    var navBounds = {
      width: nextResize.x + MARGIN
    };

    if (nextResize.x !== resizeNav.x) {
      setResizeNav(nextResize);
    }

    setDraggable(computedLeft > X_AXIS_WIDTH);
    store.setNavBounds(navBounds);
  }, [bounds.width, resizeNav]);
  return {
    bounds: bounds,
    draggable: draggable,
    isDragging: isDragging,
    resizeNav: resizeNav,
    handleDrag: handleDrag,
    handleStartDrag: handleStartDrag,
    handleUnsetDrag: handleUnsetDrag
  };
};